"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ImportFromUrlForm = void 0;

var React = _interopRequireWildcard(require("react"));

var _graphqlGen = require("../graphqlGen");

var _core = require("@emotion/core");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function buildUrlFromString(urlString) {
  if (!urlString.startsWith("http") || !urlString.startsWith("https")) {
    urlString = `http://${urlString}`;
  }

  var url = new URL(urlString);
  return url;
}

class ImportFromUrlForm extends React.Component {
  constructor(props) {
    super(props);

    _defineProperty(this, "driver", new _graphqlGen.GraphQlGenDrivers());

    _defineProperty(this, "flexContainerStyle", {
      'display': 'flex'
    });

    _defineProperty(this, "submitButtonStyle", {
      'display': 'flex',
      'flex-direction': 'row-reverse',
      'flex-basis': '50%'
    });

    this.state = {
      'importUrl': "https://graphqlpokemon.favware.tech/",
      'folderName': "catch_em_all",
      'baseUrl': "https://graphqlpokemon.favware.tech/",
      'baseUrlTouched': false
    };
    this.handleChange = this.handleChange.bind(this);
    this.handleSubmit = this.handleSubmit.bind(this);
  }

  async componentDidMount() {
    this.setState({
      'importURL': ""
    });
  }

  async handleSubmit(event) {
    try {
      var importUrlString = document.getElementById('importUrl').value;

      try {
        var url = buildUrlFromString(importUrlString);
        this.setState({
          'importUrl': url
        });
      } catch {
        this.setState({
          'importUrl': ""
        });
      }

      var folderName = document.getElementById('folderName').value;
      this.setState({
        'folderName': folderName
      });
      var baseUrl = document.getElementById('baseUrl').value;
      this.setState({
        'baseUrl': baseUrl
      });
      console.debug("Generating by URL: " + this.state);
      await this.driver.generateGraphQlFromUrl(this.props.context, this.props.models, folderName, baseUrl, await url);
    } catch (e) {
      console.error(e);
      await this.props.context.app.alert('Error!', 'Something went wrong.');
    }

    event.preventDefault();
  }

  handleChange(event) {
    const {
      target: {
        name,
        value
      }
    } = event;

    if (name === 'importUrl') {
      if (this.state.baseUrlTouched === false) {
        this.setState({
          'baseUrl': value
        });
      }

      try {
        buildUrlFromString(value);
        event.target.setCustomValidity("");
      } catch {
        event.target.setCustomValidity("Invalid URL");
        event.target.reportValidity();
      }
    } else if (name === 'baseUrl') {
      this.setState({
        'baseUrlTouched': true
      });
    }

    this.setState({
      [name]: value
    });
  }

  render() {
    return (0, _core.jsx)("form", {
      onSubmit: this.handleSubmit,
      className: "pad"
    }, (0, _core.jsx)("div", {
      className: "form-control form-control--outlined"
    }, (0, _core.jsx)("label", null, "Import URL:", (0, _core.jsx)("input", {
      id: "importUrl",
      name: "importUrl",
      type: "text",
      placeholder: "",
      value: this.state.importUrl,
      onChange: this.handleChange
    })), (0, _core.jsx)("label", null, "Folder Name:", (0, _core.jsx)("input", {
      id: "folderName",
      name: "folderName",
      type: "text",
      placeholder: "",
      value: this.state.folderName,
      onChange: this.handleChange
    })), (0, _core.jsx)("label", null, "Generated Request Base URL:", (0, _core.jsx)("input", {
      id: "baseUrl",
      name: "baseUrl",
      type: "text",
      placeholder: "",
      value: this.state.baseUrl,
      onChange: this.handleChange
    }))), (0, _core.jsx)("div", {
      style: this.flexContainerStyle
    }, (0, _core.jsx)("div", {
      className: "margin-top",
      style: this.submitButtonStyle
    }, (0, _core.jsx)("button", {
      type: "submit"
    }, "Import"))));
  }

}

exports.ImportFromUrlForm = ImportFromUrlForm;